<%@ page language="java" contentType="text/html;charset=UTF-8" pageEncoding="UTF-8" %>
<!-- enable:SMARTPAGE -->
<html>
<head>
<link rel=stylesheet TYPE="text/css" href="../css/menu.css" title="Default">
<title>RAD Service Tree</title>
<script language="JavaScript" src="../scripts/rightclickmenu.js"></script>
<script language="JavaScript" type="text/javascript">

// This global array holds all the tree nodes
var nodes_array = new Array()

// This global array holds all the action
// The action array holds "action objects". Each object is itself an array containing actionName
// action_array
// [0] -> action [0].actionName = new actionNode()
//               [1] -> action  [0] = new actionNode()
//               [2] -> action  [1] = new actionNode()
// [1] -> action

// global action array with all the actions
//var action_array = new Array()

	//var actionRoot = new Array()

// This global variable holds the currently displayed document
var current_document = -1

// This global variable holds the current node
var current_node

// set SessionID

<!-- insert:SESSIONIDVAR -->
var sessionID = '<%= session.getId() %>'

// Global Var to hold current RightClickMenu
var currentRightClickMenu = null;

// set showParentsChildrenChooser to true to show PARENTS/CHILDREN chooser
// when traversing in the tree.  This will get set to true if
// root is specified on the URL.
var showParentsChildrenChooser = 'false'
//var showParentsChildrenChooser = 'true'


// Pre-load the images
var temp_image = new Image(22, 16)
temp_image.src = "../menu_images/open.gif"
var temp_image = new Image(22, 16)
temp_image.src = "../menu_images/closed.gif"
var temp_image = new Image(18, 13)
temp_image.src = "../menu_images/plus.gif"
var temp_image = new Image(18, 13)
temp_image.src = "../menu_images/minus.gif"
var temp_image = new Image(18,18)
temp_image.src = "../menu_images/treebar.gif"
var temp_image = new Image(18,18)
temp_image.src = "../menu_images/treetee.gif"
var temp_image = new Image(18.18)
temp_image.src = "../menu_images/treecorner.gif"
var temp_image = new Image(18,18)
temp_image.src = "../menu_images/menu_open.gif"
var temp_image = new Image(18,18)
temp_image.src = "../menu_images/menu_closed.gif"
var temp_image = new Image(18,18)
temp_image.src = "../menu_images/menu_corner_minus.gif"
var temp_image = new Image(18,18)
temp_image.src = "../menu_images/menu_corner_plus.gif"
var temp_image = new Image(18,18)
temp_image.src = "../menu_images/menu_tee_minus.gif"
var temp_image = new Image(18,18)
temp_image.src = "../menu_images/menu_tee_plus.gif"

// globabl variables used in functions that are called
// outside the scope of this page
var new_node
//var main_node = new Array()

var next_index
var child_node
var level
var painter 
var rightClickMenuPainter 
// end of globals

// variables used for actions
var actionTypeID;
var actionInstanceID;
var actionInstanceName;
var actionTypeName; 


var anchorName="";
var parentIndexLastClicked = 0;
var childIndexLastClicked = 0;

//right click menu
var rightClickMenu;

// This function creates a node in the tree with the following arguments:
//    level - The level within the tree hierarchy (0 = top)
//    index - The node's index within the global nodes_array
//    text  - The text displayed in the tree for this node
//    state - Folder: "open" (expanded) or "closed" (collapsed)
//            Document: "open" (displayed) or "closed" (hidden)
//    url   - For a document, the address it will display when clicked
//    type  - the type of node parent or child
//    id    - the id that is used to get the children of the node on the backend

function node_data (level, index, text, state, url, type, id) {
    this.level = level
    this.index = index
    this.text = text
    this.state = state
    this.url = url
    this.type = type
    this.id = id
}

// This function creates a node in the tree; the
// arguments are used by the node_data() function

function create_node(level, text, state, url, type, id) {

    // Create a new node array
    new_node = new Array()
    
    // Put it in the global nodes_array
    var nodes_index = nodes_array.length
    nodes_array[nodes_index] = new_node

    // The first item in the array is the node_data object
    new_node[0] = new node_data(level, nodes_index, text, state, url, type, id)
    
    // Return the array
    return new_node
}

function add_action_node(containerName, name, displayName, actionCommand, iconName) {
	//alert("add action node name: " + name);
	if (containerName == "ROOT") {
		rightClickMenu.addMenuItem(name,displayName,actionCommand, iconName);
	} else {
		var parentMenu = rightClickMenu.getMenuByName(containerName);
		if(parentMenu != null) {
			//alert(" adding an action node, containerName: " + containerName + " parent: "+ parentMenu);
			parentMenu.addMenuItem(name,displayName,actionCommand, iconName);
		}	
	}
}

function add_menu_container(containerName, name, displayName, iconName) {
	//alert("add menu container: " + name);
	//alert("adding container: " + name  + " to: " + containerName); 
 	var subMenu = new Menu(name, displayName, iconName);
	if (containerName == "ROOT") {
		rightClickMenu.addChildMenu(subMenu);
	} else {
		var parentMenu = rightClickMenu.getMenuByName(containerName);
		if(parentMenu != null) {
			parentMenu.addChildMenu(subMenu);
		} else {
			//alert("I was returned a null parent");
		}	
	}
}

// This function adds a child to an existing parent node
function add_root_from_server(name,type,action,id) {
    // Begin with the main node
    main_node = create_node(0,name,"closed",action,type,id)

    // retunr main_node
    return main_node
}
 
// This function adds a child to an existing parent node
function add_child_from_server(parent_node, name, type, action,id) {

    level = parseInt(parent_node[0].level,10)+parseInt(1,10)	
    child_node = create_node(level,name,"closed",action,type,id)

    // We're adding an item to the parent's array, so the array's
    // current length represents the next index of that array
    next_index = parent_node.length
    
    // Add the child node to the parent's array
    parent_node[next_index] = child_node

    // Return the child
    return child_node
}

// This function builds the node of the navigation tree
function build_tree() {

    // Begin with the default main node
    main_node = create_node(-1,"Main Folder", "closed", "","parent","0")
    current_node = main_node

    //add_root_from_server("Main Folder","child","","0")
    painter = 0;

    frames["content_frame"].document.writeln('<html><body class="base"> ')
    //frames["content_frame"].document.writeln('<form name=getRoot method="post" action="/servlet/com.micromuse.sla.webclient.ServiceTemplateTreeServlet" target=content_frame>')
    frames["content_frame"].document.writeln('<form name=getRoot method="post" action="ServiceTemplateTreeServlet" target=content_frame>')

    // see if the root ID was passed in as a parameter on the URL -- this
    // is kind of like doing a CGI script within a normal javascript page.

    var documentLoc = String(document.location);
    var startingIDPos = documentLoc.indexOf("=") + 1
    var startingID = 'root'
    if (startingIDPos > 0) {
      startingID = documentLoc.substr(startingIDPos) 
      // show parent/children if started from right click option
      showParentsChildrenChooser = 'true'
    }


//    frames["content_frame"].document.writeln('<input type="hidden" name="id" value="root">');
    frames["content_frame"].document.writeln('<input type="hidden" name="id" value="' + startingID + '">');
    frames["content_frame"].document.writeln('<input type="hidden" name="SMSessionID" value="'+sessionID+'">');
    frames["content_frame"].document.writeln('<input type="hidden" name="ShowParentsChildrenChooser" value="'+showParentsChildrenChooser+'">');
    frames["content_frame"].document.writeln('</form>');							    
    frames["content_frame"].document.writeln('</body></html>');
    frames["content_frame"].document.close();
	
    setTimeout("submitInitForm()",600);
    setTimeout("write_menu_from_server()",600)
}

function submitInitForm() {
    frames["content_frame"].document.getRoot.submit()
}


function write_menu() {
    // Clear the frame and write the basic opening tags
    frames["tree_frame"].document.clear()
    frames["tree_frame"].document.writeln('<html>')
   
    frames["tree_frame"].document.writeln('<style type="text/css">')
    frames["tree_frame"].document.writeln('A:active{background:yellow}')
    frames["tree_frame"].document.writeln('a:hover { color: #006699; text-decoration: none; }')
    frames["tree_frame"].document.writeln('a { color: #000033; text-decoration: none;}')
    frames["tree_frame"].document.writeln('</style>')
 

    frames["tree_frame"].document.writeln('<head>')
    frames["tree_frame"].document.writeln('<script language="JavaScript" type="text/javascript">')
    frames["tree_frame"].document.writeln('  function showRightClickMenu(typeID, typeName) {')
			//    frames["tree_frame"].document.writeln('    displayMenu(instanceName)')
    //frames["tree_frame"].document.writeln('    parent.showRightClickMenu(typeID, typeName)')
    frames["tree_frame"].document.writeln('  }')
 
    frames["tree_frame"].document.writeln('  function displayNewVespaMap(typeID) {')
    frames["tree_frame"].document.writeln('    var sendCmds = false')
    frames["tree_frame"].document.writeln('    if (navigator.userAgent.indexOf("MSIE") >= 0) {')
    frames["tree_frame"].document.writeln('    }')
    frames["tree_frame"].document.writeln('	bringUpStatusView(typeID)');
    frames["tree_frame"].document.writeln('}')

  frames["tree_frame"].document.writeln(' function bringUpStatusView(typeID) { ')
    frames["tree_frame"].document.writeln('      parent.parent.SelectViewEditTemplate(typeID) ');
   frames["tree_frame"].document.writeln(' } ');


    frames["tree_frame"].document.writeln('\</script\>')

    frames["tree_frame"].document.writeln('<link rel="stylesheet" type="text/css" href="../css/menu.css">')
    frames["tree_frame"].document.writeln('<link rel=stylesheet TYPE="text/css" href="../styles/master.css" title="Default">');
    frames["tree_frame"].document.writeln('<\/head>')
    frames["tree_frame"].document.writeln('<title>')
    frames["tree_frame"].document.writeln('Menu Frame')
    frames["tree_frame"].document.writeln('<\/title>')
    //frames["tree_frame"].document.writeln('<body class="base"  onload="location.hash=\''+anchorName+'\';">')
    frames["tree_frame"].document.writeln('<body class="base" background="../images/white_scan_lines.png"  ');
    var anchorsSupported = true;
    if ((navigator.userAgent.indexOf("MSIE 5.0") != -1) || (navigator.appName.substring(0,8) == "Netscape")) {
	anchorsSupported = false;
    }    
    //if (anchorName != '' && anchorsSupported) {
    //  frames["tree_frame"].document.writeln('onload="location.href=\''+frames["tree_frame"].location.href+'#'+anchorName+'\';"');
    //}
    frames["tree_frame"].document.writeln(' >');
    // Create a table for each node

		frames["tree_frame"].document.writeln('<span id="menuContainer"></span>');

    frames["tree_frame"].document.writeln('<table border="0" cellspacing="0" cellpadding="0">')
    
    // Write the main node
//    frames["tree_frame"].document.writeln('<tr>')
//    frames["tree_frame"].document.writeln('<img src="netcool_RAD_logo.gif">')
//    frames["tree_frame"].document.writeln('</tr>')
   
 
    //write nodes and close the BIG table
    write_children(main_node, "")
    frames["tree_frame"].document.writeln('<\/table>')


    // Finish up
    frames["tree_frame"].document.writeln('<\/body>')
    frames["tree_frame"].document.writeln('<\/html>')
    frames["tree_frame"].document.close()
    // set painter
		painter = 0

}

function createRightClickMenu() {
  var rightClickParentElement = frames["tree_frame"].document.getElementById("menuContainer");
  rightClickMenu.create(rightClickParentElement, frames["tree_frame"]);
	rightClickMenu.showMenu(savedEventX,savedEventY);
}

// BIG HACK -- need to save the event off because when we will loop to wait for the
// right click menu to finish we are using settimeout and that loses the event for some reason
var savedEventX;
var savedEventY;



function showRightClickMenu(typeID, typeName) {   
  if(currentRightClickMenu != null &&
     currentRightClickMenu.isMenuVisible()) {
    currentRightClickMenu.closeCurrentMenu();
  }
  rightClickMenu = new Menu(); // init the menu each time
  var tmpId = typeID;
  rightClickMenuPainter = 0;
  frames["action_frame"].document.writeln('<html><body class="base">')
  frames["action_frame"].document.writeln('<form name=test method="post" action="ServiceTemplateTreeServlet" target=action_frame>')
  frames["action_frame"].document.writeln('<input type="hidden" name="id" value="'+tmpId+'">');
  frames["action_frame"].document.writeln('<input type="hidden" name="rightClickActions" value="true">');
  frames["action_frame"].document.writeln('</form>');
  frames["action_frame"].document.writeln('</body></html>');
  frames["action_frame"].document.test.submit()
  frames["action_frame"].document.close();
  savedEventX = frames["tree_frame"].event.clientX;
  savedEventY = frames["tree_frame"].event.clientY;
  currentRightClickMenu = rightClickMenu;
  write_right_click_menu();
}



function SwapImage( img_name, img_src, id) {
  for (i=0; i < frames["tree_frame"].document.images.length; i++) {
   if (frames["tree_frame"].document.images[i].name == img_name) {
     frames["tree_frame"].document.images[i].src = img_src
   }
  }

  //uncomment this out if you know they won't have the instance on multiples anches
  //you also need to comment out the loop above
  //if (frames["tree_frame"].document[img_name] != null) {
    //frames["tree_frame"].document[img_name].src = img_src
  //}
  getNodeFromIdAndUpdateText(main_node,id,img_src,img_name)
}

function getNodeFromIdAndUpdateText( parent_node, id,img_src,img_name) {
 var child_node

 for (var counter = 1; counter < parent_node.length; counter++) {
  child_node = parent_node[counter]

  if (child_node[0].id == id) {

    //store the child text
    text = child_node[0].text

    //create a string that is name="id"
    tmp = 'name=\"'+img_name+ '\" src=\"'
    //tmp = img_name

    //get the first index of where that is
    tmpIndex = text.indexOf(tmp,0);

    //get the string up until src="
    beginStr = text.substring(0,tmpIndex+ tmp.length);

    //using the image suffix to find the end of the string
    imageSuffix =  '.png'

    //get a substring with a bunch of characters from the src tag just to include the .png
    subStrWithOldImage = text.substring(beginStr.length,beginStr.length+40)

    //want to get where the imageSuffixIs
    pointOfSuffix = subStrWithOldImage.indexOf(imageSuffix,0)

    //get the ending of the string after the image name
    endStr = text.substring(beginStr.length+pointOfSuffix+4,text.length)

    newString = beginStr + img_src + endStr

    child_node[0].text = newString
  } else {
    getNodeFromIdAndUpdateText(child_node, id,img_src,img_name)
  }
 }
}

// This function writes all the child node for whatever
// parent node is specified as the argument. Note that
// this function is called recursively whenever any
// child node has children of its own.

function write_children(parent_node, nodebelow) {

    var child_node
    var indent_width
    var indents
    var tempstr

    // Run through all of the parent's child nodes
    // parent_node[0] refers to the parent node itself, so start at 1
    for (var counter = 1; counter < parent_node.length; counter++) {
        tempstr = nodebelow
        // Store the child node
        child_node = parent_node[counter]
        
        // First check to see if this is a folder or a document
        var its_a_folder = true
        if (child_node[0].type == "child") {
            its_a_folder = false
        }

        frames["tree_frame"].document.writeln('<tr>')
       //width below was 185 
        frames["tree_frame"].document.writeln('<td valign="bottom" width="185" nowrap >')

        for (var x=0; x< nodebelow.length; x++){
          if (tempstr.substring(0,1) == "0"){
             frames["tree_frame"].document.writeln('<img src="../menu_images/invisible.gif" width="13" height="18" vspace="0" hspace"0" border="0" align="left">')
          }else {
             frames["tree_frame"].document.writeln('<img src="../menu_images/treebar.gif" align="left" border="0" vspace="0" hspace="0" width="18" height="18">')
          }
          tempstr = tempstr.substring(1, tempstr.length)
//frames["tree_frame"].document.writeln('<td>tempstr: ' + tempstr + ' x: ' + x +'</td>')
        }

        // Handle folders and documents separately
        if (its_a_folder) {

            //frames["tree_frame"].document.writeln('<a href=#'+child_node[0].id + ' onclick="javascript:parent.toggle_state(\'' + child_node[0].index + '\')">')
            frames["tree_frame"].document.writeln('<a name=#'+child_node[0].id + ' onclick="javascript:parent.toggle_state(\'' + child_node[0].index + '\',event)">')
            
            if (child_node[0].state == "closed") {
                 if (counter != parent_node.length -1 ) {
                    frames["tree_frame"].document.write('<img src="../menu_images/menu_tee_plus.gif" align="left" border="0" vspace="0" hspace="0" width="18" height="18"></a>')
                 } else {
                    frames["tree_frame"].document.write('<img src="../menu_images/menu_corner_plus.gif" align="left"  border="0" vspace="0" hspace="0" width="18" height="18"></a>')
                 }
	      if (child_node[0].url == "folder"){
	 	 frames["tree_frame"].document.write('<img src="../menu_images/closed.gif"   border="0" align="left" vspace="0" hspace="0" width="18" height="18">')
              }
            }
            else {
                if (counter != parent_node.length -1 ) {
                    frames["tree_frame"].document.write('<img src="../menu_images/menu_tee_minus.gif" align="left" border="0" vspace="0" hspace="0" width="18" height="18"></a>')
                 } else {
                    frames["tree_frame"].document.write('<img src="../menu_images/menu_corner_minus.gif" align="left" border="0" vspace="0" hspace="0" width="18" height="18"></a>')
                 }
                
	     if (child_node[0].url == "folder"){
	 	frames["tree_frame"].document.write('<img src="../menu_images/open.gif" align="left" border="0" vspace="0" hspace="0" width="18" height="18">')
              }
            }
            //frames["tree_frame"].document.writeln('<\/td>')
            //frames["tree_frame"].document.writeln('<td>')
            frames["tree_frame"].document.writeln(child_node[0].text)
            
            frames["tree_frame"].document.writeln('<\/td>')

            frames["tree_frame"].document.writeln('<\/tr>')
            //frames["tree_frame"].document.writeln('<\/table>')

            // If this child's state is "open", recursively call
            // this function to write the child's children (if any)
            if (child_node[0].state == "open") {
               if (counter != parent_node.length-1)
                write_children(child_node, nodebelow+"1")
               else {
                write_children(child_node, nodebelow+"0")
               }
            }
        }
        else {
        
            // Is it the currently displayed document?
            if (child_node[0].index == current_document) {
                frames["tree_frame"].document.writeln(child_node[0].text)
            }
            else {
               //if to determine whether to use corner or tee image
               if (counter != parent_node.length-1){
                  frames["tree_frame"].document.writeln('<img src=../menu_images/treetee.gif  align="left" border="0" vspace="0" hspace="0" width="18" height="18">') 
               } else {
                  frames["tree_frame"].document.writeln('<img src=../menu_images/treecorner.gif align="left" border="0" vspace="0" hspace="0" width="18" height="18">')
               }
               frames["tree_frame"].document.writeln(child_node[0].text)
            }                        
            frames["tree_frame"].document.writeln('<\/td>')
            frames["tree_frame"].document.writeln('<\/tr>')
        }
    }
}

function write_right_click_menu() {
    if (rightClickMenuPainter == 0){
       timeout = setTimeout("doNothingRightClick()",50)
    }else {
       timeout = setTimeout("createRightClickMenu()",50)
    }
}

function write_menu_from_server(){
    if (painter == 0){
       timeout = setTimeout("doNothing()",50)
    }else {
       timeout = setTimeout("write_menu()",50)
    }							  
}

function doNothingRightClick(){
    write_right_click_menu()
}

function doNothing(){
    write_menu_from_server()
}						 

function toggle_state(node_index) {
    
    // Get the node from the global nodes_array
    current_node = nodes_array[node_index]

    // Store the node's current state
    current_state = current_node[0].state

    //store the anchor value
    anchorName=current_node[0].id
    
    if (current_state == "closed" && current_node.length == 1){
        frames["content_frame"].document.writeln('<html><body class="base">')
        frames["content_frame"].document.writeln('<form name=test method="post" action="ServiceTemplateTreeServlet" target=content_frame>')
	frames["content_frame"].document.writeln('<input type="hidden" name="id" value="'+current_node[0].id+'">');
	frames["content_frame"].document.writeln('<input type="hidden" name="ShowParentsChildrenChooser" value="'+showParentsChildrenChooser+'">');	
        frames["content_frame"].document.writeln('</form>');							    
        frames["content_frame"].document.writeln('</body></html>');
	frames["content_frame"].document.test.submit()						  
        write_menu_from_server()
    } else {
        timeout_id = setTimeout("write_menu()", 50)
    }
    // Change it to the other state
    if (current_state == "open") {
        current_node[0].state = "closed"
    }
    else {
        current_node[0].state = "open"
    }
    
    // Is this a document?
       if (current_node.length == 1) {
        if (current_document != -1) {
            nodes_array[current_document].state = "closed"
            // Rewrite the menu
            timeout_id = setTimeout("write_menu()", 50)
        }
        current_document = current_node[0].index
        // if you want the document to execute uncomment next line
        //frames["content_frame"].location = current_node[0].url
    }
    					     
    
}


function executeAction(action) {
    // do action subsitutions 
    //var replace = /__ServiceInstanceID__/;
    //action = action.replace(replace,"1:"+actionInstanceID);

    //alert(action + "        javascript:alert('test3')");
    //action="javascript:alert('test3')";

    //frames["tree_frame"].location = "javascript:top.frames['dashboard'].dispatchAction('RightClickEditInstance','64')";
    //parent.location = "javascript:top.frames['dashboard'].dispatchAction('RightClickEditInstance','64')";

    //top.frames['dashboard'].dispatchAction('RightClickEditInstance','64');
    //parent.createNewInstance();
    //alert(top.frames.length + " dash: " + top.frames['dashboard']);
    //this.location="javascript:top.frames['dashboard'].dispatchAction('RightClickEditInstance', '1:64')";
    if (action.indexOf("javascript") != -1) {
      this.location=action;
    } else {
      window.open(action,"","toolbar=no,menubar=no,location=no,resizable=yes,width=340, height=220"); 
    }

    //frames["tree_frame"].location = "javascript:alert('test')"
}
</script>

<frameset cols="99%,0%,0%" onLoad="build_tree()" frameborder="0" border="0" framespacing="0">
    <frame src="Tree" name="tree_frame"> 
    <frame src="Content" name="content_frame">
    <frame src="Content" name="action_frame">
</frameset> 


</html>












