<html>
	<%@ page language="java" contentType="text/html;charset=UTF-8" pageEncoding="UTF-8" %>
	<%@ taglib uri="http://java.sun.com/jsf/core" prefix="f" %>
  <%@ taglib uri="http://java.sun.com/jsf/html" prefix="h" %>
	<%@ taglib uri="http://java.sun.com/jstl/core" prefix="c" %>
  <%@ taglib uri="http://micromuse.com/ncjsf" prefix="ncjsf" %>
	<%@ page import="com.micromuse.response.dblayer.ConfigRepository" %>
  <f:view>
		<f:loadBundle basename="radlabels" var="rad_labels"/>
	  <head>
	    <title><h:outputText value="#{rad_labels.eventMetricRule_title}"/></title>
    <link rel="stylesheet" type="text/css" href="../../netcool/styles/master.css"/>
    <script language="Javascript" src="../../netcool/scripts/script.js"> </script>
 		<script language="JavaScript" src="../../scripts/common.js"></script>
 		<script language="JavaScript" src="../../netcool/scripts/dom_popupwindow.js"></script>
    <script language="JavaScript">
			var requiredFields = new Array();
			var requiredFieldsEvalJS = null;
			var requiredFieldsExecJS = null;
			requiredFields[0] = 'mainForm:RuleName';
			requiredFields[1] = 'mainFormdiscriminatorSelectedValues';
			requiredFields[2] = 'mainForminstanceNamesSelectedValues';
			requiredFields[3] = 'mainForm:outputExpression';
			var attributeName = encodeParameter('<h:outputText value="#{jsfBeanRetriever.ruleConfigProperties.ruleName}" />');
			var jsfid = encodeURI('<h:outputText escape="false" value="#{jsfBeanRetriever.paramId}"/>');

			function displayError() {
        var errorTxt = document.getElementById('errorDIV').innerHTML;
        if ( errorTxt.replace(/^\s*|\s*$/g,"") != '' ) {
				  document.getElementById('displayError').innerHTML = errorTxt;
			  }
      }

      function openEventViewer() {
				var type = '<h:outputText value="#{jsfBeanRetriever.ruleConfigProperties.dataFeedType}"/>';
				var datafeed = encodeParameter('<h:outputText escape="false" value="#{jsfBeanRetriever.ruleConfigProperties.dataFeedForJScript}"/>');
				var filter = encodeParameter('<h:outputText escape="false" value="#{jsfBeanRetriever.ruleConfigProperties.filterForRawAttribute}"/>');

				var coord = getCenterCoordinates(550, 350);
				var screenX = ns?'screenX='+coord[0]:'left='+coord[0];
				var screenY = ns?'screenY='+coord[1]:'top='+coord[1];
				var weasel = null;
				if ( type.toLowerCase() == 'objectserver' ) {
     			weasel = this.open("/sla/EventDisplayer?view=RawEvents&WebtopEntityName=Dynamic_"+attributeName+"_MatchingEvents&RADEntityName=0:0&RADEventFilterType=RawAttributeViewer&jsfid="+jsfid, "rawEventWin", "toolbar=no,menubar=no,location=no,resizable=yes,width=800,height=400,'+screenX+','+screenY+ ',scrollbars=yes,scrollbars=1");    
				} else {
					// open dbpoller viewer
  				weasel = window.open('../../rad/databrowser/ViewData.faces?jsfid=viewdataRA&dbpollerName='+datafeed+'&filter='+filter,'RawAttributeViewEvents','width=550,height=350,'+screenX+','+screenY+ ',status=no,resizable=yes,toolbar=no,location=no,menubar=no,directories=no,scrollbars=yes',true);
				}
      }
      
      function submitForm(action) {
        //openLoadingWindow('../loading.html', 250, 200);
        if ( document.getElementById('mainForm:advanceMetricFilter') ) {
          if ( document.getElementById('mainForm:advanceMetricFilter').checked ) {
            if ( action && action == 'custom' ) 
             document.getElementById('mainForm:configuremetricfilters').value='custom';
            else
             document.getElementById('mainForm:configuremetricfilters').value='noset';
          }
        }
				document.getElementById('mainForm').submit();
      }

			function saveMetricRule() {
       // openLoadingWindow("../../saving.html");
				document.getElementById('mainForm:saveMetricRule').value='true';
        if ( document.getElementById('mainForm:advanceMetricFilter') ) {
          if ( document.getElementById('mainForm:advanceMetricFilter').checked ) 
            document.getElementById('mainForm:configuremetricfilters').value='noset';
        }
				document.getElementById('mainForm').submit();
			}

      function disableStatusFields(chkobj) {
      	document.getElementById('mainForm:badStatus').disabled = !chkobj.checked;
      	document.getElementById('mainForm:marginalStatus').disabled = !chkobj.checked;
				if ( chkobj.checked ) {
					// disable
      		document.getElementById('mainForm:badStatus').style.backgroundColor = '#FFFFFF';
      		document.getElementById('mainForm:marginalStatus').style.backgroundColor = '#FFFFFF';
				} else {
					// enable
      		document.getElementById('mainForm:badStatus').style.backgroundColor = '#DDDDDD';
      		document.getElementById('mainForm:marginalStatus').style.backgroundColor = '#DDDDDD';
				}
      }
			
   		function popupAdvancedInstanceExpressions() {
				var coord = getCenterCoordinates(550, 350);
				var screenX = ns?'screenX='+coord[0]:'left='+coord[0];
				var screenY = ns?'screenY='+coord[1]:'top='+coord[1];
     		NewWin = this.open("../../rad/CustomInstanceExpressions.faces?isCustomExprNew=true&jsfid="+jsfid, "newCustomWin", "toolbar=no,menubar=no,location=no,resizable=yes,width=500,height=200,"+screenX+","+screenY);
   		}
				
  		function setViewRawEvents() {
    		document.getElementById('mainForm').viewRawEvents.value='true';
    		makePersistent();
  		}

  		function setCustomInstanceExpressions() {
    		document.getElementById('mainForm').customizeInstanceExpressions.value=true;
    		makePersistent();
  		}

  		function deleteSelectedThresholdSets() {
    		document.getElementById('mainForm').deleteThresholdSets.value=true;
    		makePersistent();
  		}

   		function addThresholdSet() {
				document.getElementById('mainForm').addThresholdSet.value=true;
				makePersistent();
   		}

  		function customizeThresholdSet(thresholdSetIndex) {
				document.getElementById('mainForm').thresholdSetToCustomize.value = thresholdSetIndex;
				makePersistent();
   		}

			function makePersistent() {
        //openLoadingWindow("../loading.html");
        if ( document.getElementById('mainForm:advanceMetricFilter') ) {
          if ( document.getElementById('mainForm:advanceMetricFilter').checked ) 
            document.getElementById('mainForm:configuremetricfilters').value='noset';
        }
				document.getElementById('mainForm').submit();
			}

      function initPage() {
        displayError();
      }

      function openHelp() {
		    openHelpWindow("<%= ConfigRepository.getProperty("help.props", "statusrule.editor.goodmarginalbad", "") %>");
      }


			<h:outputText value="#{jsfBeanRetriever.ruleConfigProperties.openEventViewer}"/>
			<c:if test="${param.customizeInstanceExpressions != null && param.customizeInstanceExpressions == 'true'}" >
				popupAdvancedInstanceExpressions();
			</c:if>
    </script>
  </head>
    
    <body onload="initPage();" class="NavigationTree" style="padding: 10px 0px 0px 10px;">
			<h:outputText value="#{jsfBeanRetriever.ruleConfigProperties.resetRule}"/>
			<h:outputText value="#{jsfBeanRetriever.ruleConfigProperties.loadRule}"/>
      <h:form id="mainForm">
	  		<h:inputHidden id="ruleerror" value=""/>
				<input type="hidden" name="editThresholdFields" value="" >
				<input type="hidden" name="addThresholdSet" value="" >
				<input type="hidden" name="thresholdSetToCustomize" value="" >
				<input type="hidden" name="deleteThresholdSets" value="" >
				<input type="hidden" name="viewRawEvents" value="" >
				<input type="hidden" name="isWizard">
				<input type="hidden" name="customizeInstanceExpressions" value="" >
				<input type="hidden" name="makePersistent" value="" >
				<div id="displayError">
				</div>
		    <table border="0" cellpadding="0" cellspacing="0" width="100%">
	<!-- put panel contents here -->
					<tr>
						<td align="center" valign="top">
							<table border="0" cellpadding="0" cellspacing="0" width="100%">	
				
								<!-- required field legend -->
								<tr>
									<td colspan="4" align="right" class="required"> 
										<span class="required" style="font-weight: normal;">
											<h:outputText value="#{rad_labels.requiredField}"/>
										</span>
									</td>
								</tr>
				
 							<!-- event-mapping name -->
								<tr>
									<td>&nbsp;</td>

									<td align="right" nowrap>
										<h:outputText value="#{rad_labels.rule_name}"/>:
									</td>
									<td class="required">*</td>
									<td>
										<h:inputText size="36" id="RuleName" onkeypress="return blockWhiteSpaceInTextField(event);" onkeyup="verifyRequiredFields('mainForm_saveMetricRulebutton', requiredFields, requiredFieldsEvalJS, requiredFieldsExecJS, null);" value="#{jsfBeanRetriever.ruleConfigProperties.ruleName}" />
									</td>
								</tr>
								<tr>
									<td colspan="4"><img src="../../netcool/images/spacer.png" border="0" width="1" height="4"></td>
								</tr>
				
								<tr>
          				<td></td>
          				<td align="right">
										<h:outputText value="#{rad_labels.rule_datasourceLabel}"/>:
									</td>
          				<td>&nbsp;</td>
          				<td>
										<h:selectOneMenu id="datafeed" onchange="submitForm();" value="#{jsfBeanRetriever.ruleConfigProperties.dataFeed}">
											<f:selectItems value="#{jsfBeanRetriever.ruleConfigProperties.dataFeedNames}"/>
										</h:selectOneMenu>
									</td>
        				</tr>
	
								<tr>
									<td colspan="4"><img src="../../netcool/images/spacer.png" border="0" width="1" height="4"></td>
								</tr>
	

 	       			<!-- view events-->
								<tr>
									<td></td>
									<td align="right" nowrap>
										<h:outputText value="#{rad_labels.rule_viewEvents}"/>:
									</td>
									<td class="required"></td>
									<td>
										<ncjsf:ncbutton id="viewEvents" imageSrc="../../netcool/images/button_view_ellipsis.png" height="23" alt="#{rad_labels.rule_viewEvents}" onClick="setViewRawEvents();"/>
									</td>
								</tr>
							<tr>
								<td colspan="4"><img src="../../netcool/images/spacer.png" border="0" width="1" height="6"></td>
							</tr>
 	      	 
 		       		<tr>
								<h:outputText rendered="#{jsfBeanRetriever.ruleConfigProperties.isDiscriminator}" escape="false" value="<td class='separator' colspan='4'>#{rad_labels.rule_eventDiscriminatorLabel}</td>"/>
							</tr>
 		       		<tr>
								<td colspan="4"><h:graphicImage rendered="#{jsfBeanRetriever.ruleConfigProperties.isDiscriminator}" value="../../netcool/images/spacer.png" style="border: 0" width="1" height="6"/></td>
							</tr>
 	       
 		       		<tr>
 		         		<td></td>
 		         		<td colspan="3">
									<h:outputText rendered="#{jsfBeanRetriever.ruleConfigProperties.isDiscriminator}" value="#{rad_labels.rule_eventDiscriminatorText}"/>
								</td>
 		       		</tr>

 		       		<tr>
								<td colspan="4"><h:graphicImage rendered="#{jsfBeanRetriever.ruleConfigProperties.isDiscriminator}" value="../../netcool/images/spacer.png" style="border: 0" width="1" height="6"/></td>
							</tr>
	
 		       		<tr>
 		         		<td></td>
 		         		<td colspan="3">
									<ncjsf:ncaccumulator rendered="#{jsfBeanRetriever.ruleConfigProperties.isDiscriminator}" id="discriminator" size="10" onchange="submitForm();" required="false" sort="true" removeImageSrc="../../netcool/images/button_remove_short.png" addImageSrc="../../netcool/images/button_add_short.png" addRemoveAllButton="false" toListLabel="#{rad_labels.rule_selectedDiscriminator}:" fromListLabel="#{rad_labels.rule_availableDiscriminator}:" value="#{jsfBeanRetriever.ruleConfigProperties.discriminators}">
										<f:selectItems value="#{jsfBeanRetriever.ruleConfigProperties.discriminatorsList}"/>
									</ncjsf:ncaccumulator>
 		         		</td>
 		       		</tr>
 		       		<tr>
								<td colspan="4"><img src="/sla/netcool/images/spacer.png" border="0" width="1" height="12"></td>
							</tr>
 		       		<tr>
								<td class="separator" colspan="4">
									<h:outputText value="#{rad_labels.rule_instanceNameLabel}"/>:
								</td>
							</tr>
 		       		<tr>
								<td colspan="4"><img src="../../netcool/images/spacer.png" border="0" width="1" height="6"></td>
							</tr>
	
 	 	      		<tr>
 	 	        		<td></td>
 	 	        		<td colspan="3">
									<h:outputText value="#{rad_labels.rule_instanceNameText}"/>:
								</td>
 	 	      		</tr>

   		     		<tr>
									<td colspan="4"><img src="../../netcool/images/spacer.png" border="0" width="1" height="6"></td>
							</tr>
        
        			<tr>
         		 		<td></td>
         		 		<td colspan="3">
									<ncjsf:ncaccumulator id="instanceNames" size="10" required="false" onchange="verifyRequiredFields('mainForm_saveMetricRulebutton', requiredFields, requiredFieldsEvalJS, requiredFieldsExecJS, null);" sort="true" addImageSrc="../../netcool/images/button_add_short.png" removeImageSrc="../../netcool/images/button_remove_short.png" addRemoveAllButton="false" toListLabel="#{rad_labels.rule_selectedInstanceNames}:" fromListLabel="#{rad_labels.rule_availableInstanceNames}:" value="#{jsfBeanRetriever.ruleConfigProperties.instanceNameFields}">
										<f:selectItems value="#{jsfBeanRetriever.ruleConfigProperties.instanceNameFieldList}"/>
									</ncjsf:ncaccumulator>
								</td>
        			</tr>
        
        			<tr>
								<td colspan="4">
									<h:graphicImage rendered="#{jsfBeanRetriever.ruleConfigProperties.isThresholdRule}" value="../../netcool/images/spacer.png" style="border: 0; width: 1; height: 12;"/>
								</td>
							</tr>
							<tr>
								<td colspan="4">
									<ncjsf:ncbutton id="toAdvanceFilter" onClick="setCustomInstanceExpressions();" imageSrc="../../images/button_adv_ellipsis.png" alt="#{rad_labels.rule_customExpression}"/>
								</td>
							</tr>
        			<tr>
								<td colspan="4">
									<h:outputText rendered="#{jsfBeanRetriever.ruleConfigProperties.areAdvancedExpressionsConfigured}" value="* Advanced Expressions are Configured" />
								</td>
							</tr>
							<tr>
								<td colspan="4"><img src="../../netcool/images/spacer.png" border="0" width="1" height="12"></td>
							</tr>
        			<tr>
								<td class="separator" colspan="4">
									<h:outputText value="#{rad_labels.eventMetricRule_metric_label}"/>:
								</td>
							</tr>
        			<tr>
								<td colspan="4"><img src="../../netcool/images/spacer.png" border="0" width="1" height="6"></td>
							</tr>

        			<tr>
	
 		         		<td></td>
 		         		<td colspan="3">
									<h:outputText rendered="#{jsfBeanRetriever.ruleConfigProperties.isThresholdRule}" value="#{rad_labels.rule_selectFieldText}:"/>
									<h:outputText rendered="#{not jsfBeanRetriever.ruleConfigProperties.isThresholdRule}" value="#{rad_labels.eventMetricRule_selectFieldText}:"/>
								</td>
 		       		</tr>

 		       		<tr>
								<td colspan="4"><img src="../../netcool/images/spacer.png" border="0" width="1" height="6"></td>
							</tr>

 		       		<tr>
 		         		<td></td>
          			<td colspan="3">
							<h:outputText value="#{jsfBeanRetriever.ruleConfigProperties.processRawEventTable}" />
									<ncjsf:ncaccumulator id="thresholdFields" size="10" disabled="#{jsfBeanRetriever.ruleConfigProperties.customized}" required="false" sort="true" addImageSrc="../../netcool/images/button_add_short.png" onchange="verifyRequiredFields('mainForm_saveMetricRulebutton', requiredFields, requiredFieldsEvalJS, requiredFieldsExecJS, null);submitForm();" removeImageSrc="../../netcool/images/button_remove_short.png" addRemoveAllButton="false" fromListLabel="#{rad_labels.rule_availableThresholdFields}:" toListLabel="#{rad_labels.rule_selectedThresholdFields}:" value="#{jsfBeanRetriever.ruleConfigProperties.thresholdFields}">
										<f:selectItems value="#{jsfBeanRetriever.ruleConfigProperties.thresholdFieldsList}"/>
									</ncjsf:ncaccumulator>
	
 		         		</td>
 		       		</tr>              

 		       		<tr>
								<td colspan="4"><img src="../../netcool/images/spacer.png" border="0" width="1" height="8"></td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td colspan="4" align="center" valign="top">
						<table border="0" cellpadding="0" cellspacing="0" width="100%">	
					<!-- Toggle Threshold or Metric -->
								<c:import url="${jsfBeanRetriever.ruleConfigProperties.ruleBottomPage}"/>
						</table>
					</td>
				</tr>
 	     	<tr>
 	     		<td colspan="4">
       		  <!-- button bar -->
						<ncjsf:ncbuttonBar helpHref="javascript:openHelp()">
							<ncjsf:ncbutton id="saveMetricRulebutton" onClick="saveMetricRule();" imageSrc="../../netcool/images/button_ok.png" alt="#{rad_label.okText}"/>
							<ncjsf:ncbutton id="resetMetricRule" imageSrc="/sla/netcool/images/button_cancel.png" alt="#{rad_label.cancelText}" onClick="window.close();"/>
						</ncjsf:ncbuttonBar>
       	 </td>
    	  </tr>
			</table>
			<h:inputHidden id="jsfid" value="#{jsfBeanRetriever.paramId}"/>
			<h:inputHidden id="saveMetricRule" value="false"/>
		</h:form>
		<script language="Javascript">
			verifyRequiredFields('mainForm_saveMetricRulebutton', requiredFields, requiredFieldsEvalJS, requiredFieldsExecJS, null);
			var saved = '<h:outputText value="#{jsfBeanRetriever.ruleConfigProperties.saveEventMappingRule}"/>';
			if ( saved && saved == 'saved' ) {
				opener.location.reload();
				// close window
				window.close();
			}
      document.getElementById('mainForm:saveMetricRule').value=false;
		</script>
    <div id="errorDIV" style="visibility: hidden;">
			<h:messages styleClass="required"/>
    </div>
		</body>
	</f:view>
</html>
