<%-- *************************************************** {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * 5724-C51
 *
 * (C) Copyright IBM Corp. 2007
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} *** --%>
<%-- ***************************************************************************
 * CMVC Location: radCommonInstallBase/guifoundation/webapps/sla/rad/servicetree.jsp, tbsm_rad, tbsm_rad_3.0
 * Version:       1.3
 * Last Modified: 07/03/28 10:26:02
 ******************************************************************************* --%>

<%@ page language="java" contentType="text/html;charset=UTF-8" pageEncoding="UTF-8" %>
<%@ page import="com.micromuse.sla.configclient.*" %>
<%@ page import="com.micromuse.sla.beans.*" %>
<%@ page import="com.micromuse.sla.soap.RADFacadeIfc" %>
<%@ page import="java.util.*" %>

<!-- enable:SMARTPAGE -->
<html>
<head>
<link rel=stylesheet TYPE="text/css" href="../css/menu.css" title="Default">
<link rel="stylesheet" type="text/css" href="../styles/master.css">	

<title>RAD Service Tree</title>
<script language="JavaScript" src="../scripts/rightclickmenu.js"></script>
<script language="JavaScript" src="../scripts/getadditionalinfo.js"></script>
<script language="JavaScript" src="../scripts/treecolors.js"></script>
<script src="../scripts/prototype-1.3.1.js"></script>


<%
// depending on the parameter passed into the tree it will load the proper
// js script for instances being clicked on
  String scriptName = request.getParameter("actionMode");
  if (scriptName != null && scriptName.equals("standalone")) {
%>
  <script type="text/javascript" src="/desktop/js/vpmessaging.js"></script>


 <% 
     scriptName="standalone_tree.js";
  } else {
     scriptName="embedded_tree.js";
  }
%>


<script language="JavaScript" src="../scripts/<%=scriptName%>"></script>

<script language="JavaScript" type="text/javascript">
// This global array holds all the tree nodes
var nodes_array = new Array()
//var status_array = new Array();
var canvasStore = new Array();

// This global variable holds the currently displayed document
var current_document = -1

// This global variable holds the current node
var current_node

// This global variable holds this tree ID
var treeID

// set SessionID
<!-- insert:SESSIONIDVAR -->
var sessionID = '<%= session.getId() %>'

// Global Var to hold current RightClickMenu
var currentRightClickMenu = null;

// set showParentsChildrenChooser to true to show PARENTS/CHILDREN chooser
// when traversing in the tree.  This will get set to true if
// root is specified on the URL.
var showParentsChildrenChooser = 'false'
//var showParentsChildrenChooser = 'true'

//store the click location so we can scroll the to the right position for anchors
var clickLocation = 0;

// store the column names
var columnNames = new Array();


// Pre-load the images
var temp_image = new Image(22, 16)
temp_image.src = "../menu_images/open.gif"
var temp_image = new Image(22, 16)
temp_image.src = "../menu_images/closed.gif"
var temp_image = new Image(18, 13)
temp_image.src = "../menu_images/plus.gif"
var temp_image = new Image(18, 13)
temp_image.src = "../menu_images/minus.gif"
var temp_image = new Image(18,18)
temp_image.src = "../menu_images/treebar.gif"
var temp_image = new Image(18,18)
temp_image.src = "../menu_images/treetee.gif"
var temp_image = new Image(18.18)
temp_image.src = "../menu_images/treecorner.gif"
var temp_image = new Image(18,18)
temp_image.src = "../menu_images/menu_open.gif"
var temp_image = new Image(18,18)
temp_image.src = "../menu_images/menu_closed.gif"
var temp_image = new Image(18,18)
temp_image.src = "../menu_images/menu_corner_minus.gif"
var temp_image = new Image(18,18)
temp_image.src = "../menu_images/menu_corner_plus.gif"
var temp_image = new Image(18,18)
temp_image.src = "../menu_images/menu_tee_minus.gif"
var temp_image = new Image(18,18)
temp_image.src = "../menu_images/menu_tee_plus.gif"

// globabl variables used in functions that are called
// outside the scope of this page
var new_node
//var main_node = new Array()
var next_index
var child_node
var level
var painter 
var rightClickMenuPainter 
// end of globals

// variables used for actions
var actionTypeID;
var actionInstanceID;
var actionInstanceName;
var actionTypeName; 


var anchorName="";
var parentIndexLastClicked = 0;
var childIndexLastClicked = 0;

//right click menu
var rightClickMenu;

//updater var
var updater = false;

//This function sets the treeID for this serviceInstanceTree
function setTreeID(treeid) {
  treeID = treeid;
}

// This function creates a node in the tree with the following arguments:
//    level - The level within the tree hierarchy (0 = top)
//    index - The node's index within the global nodes_array
//    text  - The text displayed in the tree for this node
//    state - Folder: "open" (expanded) or "closed" (collapsed)
//            Document: "open" (displayed) or "closed" (hidden)
//    url   - For a document, the address it will display when clicked
//    type  - the type of node parent or child
//    id    - the id that is used to get the children of the node on the backend

function node_data (level, index, text, state, url, type, id) {
    this.level = level
    this.index = index
    this.text = text
    this.state = state
    this.url = url
    this.type = type
    this.id = id
}

// This function creates a node in the tree; the
// arguments are used by the node_data() function

function create_node(level, text, state, url, type, id) {

    // Create a new node array
    new_node = new Array()
    
    // Put it in the global nodes_array
    var nodes_index = nodes_array.length
    nodes_array[nodes_index] = new_node

    // The first item in the array is the node_data object
    new_node[0] = new node_data(level, nodes_index, text, state, url, type, id)
    
    // Return the array
    return new_node
}

function does_column_exist(columnName_) {
	for (var i=0; i < columnNames.length; i++) {
		if (columnNames[i] == columnName_) {
			return true;
		}
	}
	return false;
}

function add_column_name(columnName_) {
	if (columnName_ != null && columnName_ != '' && !does_column_exist(columnName_)) {
		columnNames[columnNames.length] = columnName_;
	}
}	

// This function creates a action for the action array the args are

//function create_action(name, displayName, actionCommand) {
//}

function add_action_node(containerName, name, displayName, actionCommand, iconName) {
	if (containerName == "ROOT") {
		rightClickMenu.addMenuItem(name,displayName,actionCommand, iconName);
		//alert(" adding an action node, displayName: " + displayName + " actionCommand: "+ actionCommand);
	} else {
		var parentMenu = rightClickMenu.getMenuByName(containerName);
		if(parentMenu != null) {
			//alert(" adding an action node, containerName: " + containerName + " parent: "+ parentMenu);
			//alert(" adding an action node, displayName: " + displayName + " actionCommand: "+ actionCommand);
			parentMenu.addMenuItem(name,displayName,actionCommand, iconName);
		}	
	}
}

function add_menu_container(containerName, name, displayName, iconName) {
	//alert("add menu container: " + name);
	//alert("adding container: " + name  + " to: " + containerName); 
 	var subMenu = new Menu(name, displayName, iconName);
	if (containerName == "ROOT") {
		rightClickMenu.addChildMenu(subMenu);
	} else {
		var parentMenu = rightClickMenu.getMenuByName(containerName);
		if(parentMenu != null) {
			parentMenu.addChildMenu(subMenu);
		} else {
			//alert("I was returned a null parent");
		}	
	}
}

// This function is called from displayNewVespaMap and sets up a ajax call to
// CanvasAuthorizationController.jsp to see if shouldDisplayInCanvas is set to false in
// this instances Additional Properties field. If the attribute is non-existant, the object will 
// load in the cavas as usual. 
//
// IF...
// 1.) the Attribute exists and is not set to anything,
// 2.) Exists and is set to something other then "true"
// 3.) or  is set to false
// an Alert will pop up saying that you cannot start from this instance in the canvas

function checkIfOkToLaunchCanvas(instanceID,
                                 typeName, 
                                 instanceName, 
                                 typeID, 
                                 parentIndex,
                                 childIndex) {

  var url = 'CanvasAuthorizationController.jsp';
  var pars = 'serviceInstanceID=' + instanceID + '&typeName=' + typeName + '&instanceName=' + instanceName + '&typeID=' + typeID + '&parentIndex=' + parentIndex + '&childIndex=' + childIndex;
  var myAjax = new Ajax.Request (
     url,
     {
        method: 'get',
        parameters: pars,
        onComplete: loadAuthorizationResponse
     });
}

// This function is called asynchronously from checkIfOkToLaunchCanvas and parses
// the returned result from CanvasAuthorizationController.jsp and determines whether
// a service instance may be used a starting point in the canvas
//
// BTW The point being in some huge models you may not want the user to load the 
// canvas from a starting point way up at the top of the hierarchy

function loadAuthorizationResponse(originalRequest) {
  var xmlDoc = originalRequest.responseXML;
  var shouldDisplayInCanvas = "true";
  var typeName;
  var typeID;
  var childIndex;
  var parentIndex;
  var instanceID;
  var instanceName;

  for(var i=0; i<xmlDoc.documentElement.childNodes.length; i++) {
    var tmpObj = xmlDoc.documentElement.childNodes[i];
    var attr = tmpObj.getAttribute("name");
    if(attr == "shouldDisplayInCanvas") {
      if(tmpObj.firstChild != null) {
        shouldDisplayInCanvas = tmpObj.firstChild.data;
      }
    } else if(attr == "instanceID") {
      if(tmpObj.firstChild != null) {
        instanceID = tmpObj.firstChild.data;
      }
    } else if(attr == "instanceName") {
      if(tmpObj.firstChild != null) {
        instanceID = tmpObj.firstChild.data;
      }
    } else if(attr == "typeName") {
      if(tmpObj.firstChild != null) {
        typeName = tmpObj.firstChild.data;
      }
    } else if(attr == "typeID") {
      if(tmpObj.firstChild != null) {
        typeName = tmpObj.firstChild.data;
      }
    } else if(attr == "childIndex") {
      if(tmpObj.firstChild != null) {
        childIndex = tmpObj.firstChild.data;
      }
    } else if(attr == "parentIndex") {
      if(tmpObj.firstChild != null) {
        parentIndex = tmpObj.firstChild.data;
      }
    }
  }
  if(shouldDisplayInCanvas == "true") {
    parentIndexLastClicked = parentIndex;
    childIndexLastClicked = childIndex;
    onSelectedFunction(typeName, instanceName, typeID, instanceID);
  } else { 
    alert("This Instance cannot be used as a starting point in the canvas" + 
          " please choose another Instance");
  }
}

//we now want to make a method call when something is clicked to store the parent and child indexes
//so we can do a refresh later.
function add_parent_index_to_text(text,
                                  parent_index,
                                  child_index) {
    //create a string with display new vespa map //end of the function
    tmp = ')"  onContextMenu'
    //get the first index of where that is
    tmpIndex = text.indexOf(tmp,0)

    //get the string up until src="
    beginStr = text.substring(0,tmpIndex)

    //get a substring with a bunch of characters from the src tag just to include the .png
    restOfTheString = text.substring(beginStr.length,text.length)

    newString = beginStr +','+parent_index+','+child_index + restOfTheString

    child_node[0].text = newString
}


// This function adds a child to an existing parent node
function add_root_from_server(name,type,action,id) {
    // Begin with the main node
    main_node = create_node(0,name,"closed",action,type,id)
			
    // retunr main_node
    return main_node
}
 
// This function adds a child to an existing parent node
function add_child_from_server(parent_node, name, type, action,id) {

    level = parseInt(parent_node[0].level,10)+parseInt(1,10)	
    child_node = create_node(level,name,"closed",action,type,id)

    add_parent_index_to_text(child_node[0].text,
                             parent_node[0].index,
                             child_node[0].index);

    // We're adding an item to the parent's array, so the array's
    // current length represents the next index of that array
    next_index = parent_node.length
    
    // Add the child node to the parent's array
    parent_node[next_index] = child_node

    // Return the child
    return child_node
}

function finish() {
  // check if we're in a parent frame or not before calling it
  if (parent.ShowServices) {
    parent.ShowServices();
  }
}

// This function builds the node of the navigation tree
function build_tree() {
    // Begin with the default main node
    main_node = create_node(-1,"Main Folder", "closed", "","parent","0")
    current_node = main_node

    //add_root_from_server("Main Folder","child","","0")
    painter = 0;

    frames["content_frame"].document.writeln('<html><body class="base"> ')

    frames["content_frame"].document.writeln('<form name=getRoot method="post" action="ServiceInstanceTreeServlet" target=content_frame>');
   
    // see if the root ID was passed in as a parameter on the URL -- this
    // is kind of like doing a CGI script within a normal javascript page.

//    var documentLoc = String(document.location);
//    var startingIDPos = documentLoc.indexOf("=") + 1
//    var startingID = 'root'
//    if (startingIDPos > 0) {
//      startingID = documentLoc.substr(startingIDPos) 
//      // show parent/children if started from right click option
//      showParentsChildrenChooser = 'true'
//    }

    var startingID = 'root'
     <%
			String startingID = request.getParameter("startingID");
			if (startingID != null && !startingID.equals("")){
		%>
				startingID='1:<%=startingID%>';
    <%
      }
    %>


//    frames["content_frame"].document.writeln('<input type="hidden" name="id" value="root">');
    frames["content_frame"].document.writeln('<input type="hidden" name="id" value="' + startingID + '">');
    frames["content_frame"].document.writeln('<input type="hidden" name="SMSessionID" value="'+sessionID+'">');
    frames["content_frame"].document.writeln('<input type="hidden" name="ShowParentsChildrenChooser" value="'+showParentsChildrenChooser+'">');

		<%
			String treeTemplate = request.getParameter("treeTemplate");
			if (treeTemplate == null || treeTemplate.equals("")) {
				treeTemplate = "ServiceInstance";
      } 
		%>
 



    frames["content_frame"].document.writeln('<input type="hidden" name="treeTemplate" value="<%=treeTemplate%>">');


    frames["content_frame"].document.writeln('</form>');
    frames["content_frame"].document.writeln('</body></html>');


    frames["content_frame"].document.close();
    setTimeout("submitInitForm()",600);
    setTimeout("write_menu_from_server()",600)

    // set updater to false
    updater = false;
}

function submitInitForm() {
    frames["content_frame"].document.getRoot.submit()
}

function write_menu() {
    // Clear the frame and write the basic opening tags
    frames["tree_frame"].document.clear();
    frames["tree_frame"].document.writeln('<html>');
   
    frames["tree_frame"].document.writeln('<head>');
    frames["tree_frame"].document.writeln('<style type="text/css">');
    frames["tree_frame"].document.writeln('.positioned { position: relative; }');
    frames["tree_frame"].document.writeln('A:active{background:yellow}');
    frames["tree_frame"].document.writeln('a:hover { color: #006699; text-decoration: none; }');
    frames["tree_frame"].document.writeln('a { color: #000033; text-decoration: none;}');

    frames["tree_frame"].document.writeln('</style>');
 
		// frames["tree_frame"].document.writeln('\</script\>')
    frames["tree_frame"].document.writeln('<script language="JavaScript" type="text/javascript">');
    frames["tree_frame"].document.writeln('  function showRightClickMenu(typeID, instanceID, instanceName, typeName, contextMenuEvent) {');
			//    frames["tree_frame"].document.writeln('    displayMenu(instanceName)')
    frames["tree_frame"].document.writeln('    parent.showRightClickMenu(typeID, instanceID, instanceName, typeName, contextMenuEvent)');
    frames["tree_frame"].document.writeln('  }')
    frames["tree_frame"].document.writeln('  function displayNewVespaMap(typeName, instanceName, typeID, instanceID,parentIndex,childIndex) {');
    //frames["tree_frame"].document.writeln('    parent.checkIfOkToLaunchCanvas(instanceID, typeName, instanceName, typeID, parentIndex,childIndex);');

    frames["tree_frame"].document.writeln('    parent.parentIndexLastClicked = parentIndex');
    frames["tree_frame"].document.writeln('    parent.childIndexLastClicked = childIndex');
    frames["tree_frame"].document.writeln('    parent.onSelectedFunction(typeName, instanceName, typeID, instanceID)');
    frames["tree_frame"].document.writeln('  }');

		// returns the index in the anchor array of the anchor name being passed in
    // this is used by the scrollToAnchor function to figure out where to scroll to
    frames["tree_frame"].document.writeln('function getIndexForAnchor(tLoc) {')
    frames["tree_frame"].document.writeln('  tLoc = "#"+tLoc;')
    frames["tree_frame"].document.writeln('  for (var i = 0; i<document.anchors.length; i++) {')
	  frames["tree_frame"].document.writeln('    if (document.anchors[i].name == tLoc) {')
	  frames["tree_frame"].document.writeln('      return i;')
    frames["tree_frame"].document.writeln('    }')
    frames["tree_frame"].document.writeln('  }')
    frames["tree_frame"].document.writeln('  return -1;')
    frames["tree_frame"].document.writeln('}')

	  // Function will scroll to the anchor position.  When using default anchor support the entire
    // page would scroll, so now we have a javascript method to scroll the tree window only
    frames["tree_frame"].document.writeln('function scrollToAnchor(tLoc) { ')
    frames["tree_frame"].document.writeln('  if (document.all) { ')
    //frames["tree_frame"].document.writeln('    value = document.anchors[getIndexForAnchor(tLoc)].offsetParent.offsetTop')
		frames["tree_frame"].document.writeln('    value = parent.clickLocation')
    frames["tree_frame"].document.writeln('    window.scrollTo(0,value);')
    frames["tree_frame"].document.writeln('  } else {     ')
		frames["tree_frame"].document.writeln('    window.scrollTo(0,document.anchors["tLoc"].y);')
    frames["tree_frame"].document.writeln('  }')
    frames["tree_frame"].document.writeln('}')

    frames["tree_frame"].document.writeln('\</script\>')

    frames["tree_frame"].document.writeln('<link rel="stylesheet" type="text/css" href="../css/menu.css">')
    frames["tree_frame"].document.writeln('<link rel=stylesheet TYPE="text/css" href="../styles/master.css" title="Default">');
    frames["tree_frame"].document.writeln('<link rel="stylesheet" type="text/css" href="../css/treecolors.css">');
    frames["tree_frame"].document.writeln('<\/head>');
    frames["tree_frame"].document.writeln('<title>');
    frames["tree_frame"].document.writeln('Menu Frame');
    frames["tree_frame"].document.writeln('<\/title>');
    //frames["tree_frame"].document.writeln('<body class="base" background="../images/white_scan_lines.png"  onload="location.hash=\''+anchorName+'\';">');
    // frames["tree_frame"].document.writeln('<body class="base" background="../images/white_scan_lines.png" ');
    frames["tree_frame"].document.writeln('<body class="base" ');
    var anchorsSupported = true;
    if ((navigator.userAgent.indexOf("MSIE 5.0") != -1) || (navigator.appName.substring(0,8) == "Netscape")) {
	anchorsSupported = false;
    }    
    //if (anchorName != '' && anchorsSupported) {
    //  frames["tree_frame"].document.writeln('onload="location.href=\''+frames["tree_frame"].location.href+'#'+anchorName+'\';"');
    //}
    if (anchorName != '' && anchorsSupported) {
      //frames["tree_frame"].document.writeln('onload="location.hash=\''+frames["tree_frame"].location.href=\''+'#'+anchorName+'\';parent.finish()"');
			//frames["tree_frame"].document.writeln('onload="location.href=\''+frames["tree_frame"].location.href+'#'+anchorName+'\';"');
      frames["tree_frame"].document.writeln('onload="scrollToAnchor(\''+anchorName+'\')"');
    } else {
      frames["tree_frame"].document.writeln('onload="parent.finish()"');
    }
    frames["tree_frame"].document.writeln(' >');

    // Create the right click menu
    frames["tree_frame"].document.writeln('<span id="menuContainer"></span>');
		
		// Add to Support drop shadow in CSS - 08/31/2004 RAJ
		//frames["tree_frame"].document.writeln('<span id="menuContainer" padding="2px"</span>');
    
		//frames["tree_frame"].document.writeln('<div id=rightClickMenu onclick="clickMenu()" onmouseover="switchMenu()" onmouseout="switchMenu()" style="position:absolute;display:none;width:200;background-Color:menu; border: outset 3px gray">');
    //frames["tree_frame"].document.writeln('  <div class="menuItem" id="OpenWizard">Create Child using the wizard</div>');
    //frames["tree_frame"].document.writeln('  <div class="menuItem" id="MenuItem2">Test Menu Item 2</div>');
    //frames["tree_frame"].document.writeln('  <div class="menuItem" id="MenuItem2">Test Menu Item 3</div>');
    //frames["tree_frame"].document.writeln('</div>');


    // Create a table for each node
    frames["tree_frame"].document.writeln('<table border="0" cellspacing="0" cellpadding="0" id="treeTable">')
    

		// Create Column Headings
	  frames["tree_frame"].document.writeln('<tr class="treeHeader">')
		frames["tree_frame"].document.writeln('<td valign="bottom" width="185" nowrap ></td>')	

		// add columns here
		for(var cols=0; cols<columnNames.length; cols++) {
	     //frames["tree_frame"].document.writeln('<td width="30" align="left" class="treeColumn"><div STYLE="writing-mode: tb-rl" nowrap><font size="-5">'+columnNames[cols]+'</font></div></td>')	
		 // frames["tree_frame"].document.writeln('<td width="40" align="center" nowrap class="treeColumn"><div><font size="-5">'+columnNames[cols]+'</font></div></td>')	
		 frames["tree_frame"].document.writeln('<td class="treeColumn">'+columnNames[cols]+'</td>')	
    }  

		
	  frames["tree_frame"].document.writeln('</tr>')	
 


    //write nodes and close the BIG table
    write_children(main_node, "")
    frames["tree_frame"].document.writeln('<\/table>')
    frames["tree_frame"].document.writeln('<script type="text/Javascript">');
    frames["tree_frame"].document.writeln('parent.revealTree();');
    frames["tree_frame"].document.writeln('<\/script>');


    // Finish up
    frames["tree_frame"].document.writeln('<\/body>')
    frames["tree_frame"].document.writeln('<\/html>')
    frames["tree_frame"].document.close()
    // set painter
		painter = 0

}


function createRightClickMenu() {
  var rightClickParentElement = frames["tree_frame"].document.getElementById("menuContainer");
  rightClickMenu.create(rightClickParentElement, frames["tree_frame"]);
	rightClickMenu.showMenu(savedEventX,savedEventY);
}

// BIG HACK -- need to save the event off because when we will loop to wait for the
// right click menu to finish we are using settimeout and that loses the event for some reason
var savedEventX;
var savedEventY;



function showRightClickMenu(typeID, instanceID, instanceName, typeName, contextMenuEvent) {
  if(currentRightClickMenu != null &&
     currentRightClickMenu.isMenuVisible()) {
    currentRightClickMenu.closeCurrentMenu();
  }
  rightClickMenu = new Menu(); // init the menu each time
  var tmpId = typeID + ":" + instanceID;
  rightClickMenuPainter = 0;
  frames["action_frame"].document.writeln('<html><body class="base">')
  frames["action_frame"].document.writeln('<form name=test method="post" action="ServiceInstanceTreeServlet" target=action_frame>')
  frames["action_frame"].document.writeln('<input type="hidden" name="id" value="'+tmpId+'">');
  frames["action_frame"].document.writeln('<input type="hidden" name="rightClickActions" value="true">');
  frames["action_frame"].document.writeln('</form>');
  frames["action_frame"].document.writeln('</body></html>');
  frames["action_frame"].document.test.submit()
  frames["action_frame"].document.close();
  // contextMenuEvent passed in for Firefox and IE - but worst case, fall back to IE behavior
  // (get it from the global event.
  if (!contextMenuEvent) {
    var contextMenuEvent = frames["tree_frame"].event;
  }
  savedEventX = contextMenuEvent.clientX;
  savedEventY = contextMenuEvent.clientY;
  currentRightClickMenu = rightClickMenu;
  write_right_click_menu();
}

function SwapTextWaiter(div_name, div_src, id){
    if (updater = true){
       timeout = setTimeout("doNothingSwapText()",50)
    }else {
       timeout = setTimeout("SwapText(div_name, div_src, id)",50)
    }							  
}

function doNothingSwapText( div_name, div_src, id) {
    SwapTextWaiter(div_name, div_src, id);
}

function SwapText( div_name, div_src, id) {
  var divID = frames["tree_frame"].document.getElementById(div_name);
  if (divID != null) {
    divID.innerHTML=div_src;
  }

  //for (i=0; i < frames["tree_frame"].document.images.length; i++) {
  // if (frames["tree_frame"].document.images[i].name == img_name) {
  //   frames["tree_frame"].document.images[i].src = img_src
  // }
  //}

  //uncomment this out if you know they won't have the instance on multiples branches
  //you also need to comment out the loop above
  //if (frames["tree_frame"].document[img_name] != null) {
    //frames["tree_frame"].document[img_name].src = img_src
  //}
  //alert("calling getNodeFromIdAndUpdateNumericalValues for: " + 
  //"div_name" + div_name);
  getNodeFromIdAndUpdateNumericalValues(div_name, div_src, id, main_node);
}

function getNodeFromIdAndUpdateNumericalValues(div_name, 
                                                                                      div_src, 
                                                                                      id, 
                                                                                      parent_node) {
  var child_node
  for (var counter = 1; counter < parent_node.length; counter++) {
    child_node = parent_node[counter]
    if (child_node[0].id == id) {
      //alert("childnode id: "+ id);
      text = child_node[0].text
      //alert("child_node[0].text is: " + text);
      //alert("my div_id to update is: " + div_name);
      searchString = "<div id=\"" + div_name + "\"";
      tmpIndex = text.indexOf(searchString, 0);
      if(tmpIndex != -1 && tmpIndex != '-1') {
        //alert("my div_name: "+ div_name);
        //alert("matches this entry: " + text);
        //alert("my div_src is: " + div_src);
        endOfDivIndex = text.indexOf(">", tmpIndex);
        //alert("tmpIndex is: " + tmpIndex);
        //alert("endOfDivIndex is: " + endOfDivIndex);
        beginningOfClosedDivIndex = text.indexOf("</div>", endOfDivIndex);
        //alert("beginningOfClosedDivIndex is: " + beginningOfClosedDivIndex);
        startString = text.slice(0,endOfDivIndex + 1);
        endString = text.slice(beginningOfClosedDivIndex);
        //alert("startString is: " + startString);
        //alert("endString is: " + endString);
        textEntryString = startString + div_src + endString;
        //alert("textEntryString is: " + textEntryString);
        child_node[0].text = textEntryString;
      }
   }
   getNodeFromIdAndUpdateNumericalValues(div_name, div_src, id, child_node);
  }
 }

function SwapImageWaiter(img_name, img_src, id){
    if (updater = true){
       timeout = setTimeout("doNothingSwapText()",50)
    }else {
       timeout = setTimeout("SwapImage(img_name, img_src, id)",50)
    }							  
}

function doNothingSwapImage( img_name, img_src, id) {
    SwapImageWaiter(img_name, img_src, id);
}



function SwapImage(img_name, img_src, id) {
  var tmpImg = frames["tree_frame"].document.getElementById(img_name);
  if(tmpImg != null && tmpImg != 'undefined') {
    tmpImg.src = img_src;
  }

  //uncomment this out if you know they won't have the instance on multiples anches
  //you also need to comment out the loop above
  //if (frames["tree_frame"].document[img_name] != null) {
  //  frames["tree_frame"].document[img_name].src = img_src
  //}
  getNodeFromIdAndUpdateText(main_node,id,img_src,img_name)
}

function getNodeFromIdAndUpdateText( parent_node, id,img_src,img_name) {
 var child_node

 for (var counter = 1; counter < parent_node.length; counter++) {
  child_node = parent_node[counter]

  if (child_node[0].id == id) {
     //alert("match of an update request childnode id: "+ id);
          //store the child text
    text = child_node[0].text

          //alert("childnode text: "+ text + " img_name: " + img_name);
          //create a string that is name="id"
          //tmp = 'name=\"'+img_name+ '\" align=\"center\"'
          //tmp = 'name=\"'+img_name+ '\" align'
    tmp = 'id=\"'+img_name+'\" src=\"'
          //tmp = 'id=\"'+img_name
          //tmp = img_name
          //alert("tmp: "+ tmp);
          //get the first index of where that is
    tmpIndex = text.indexOf(tmp,0);
    if (tmpIndex != -1 && tmpIndex != '-1') {
          //alert("tmpIndex: " + tmpIndex);
          //get the string up until src="
       beginStr = text.substring(0,tmpIndex+ tmp.length);
	      //alert("beginStr: " + beginStr);
    	  //using the image suffix to find the end of the string
    	imageSuffix =  '.png'
	      //alert("imageSuffix: " + imageSuffix);
      	pointOfSuffix = text.indexOf(imageSuffix,beginStr.length)
        	//alert("pointOfsuffix: " + pointOfSuffix);
      	    //get a substring with a bunch of characters from the src tag just to include the .png
    	    //subStrWithOldImage = text.substring(beginStr.length,beginStr.length+40)
        subStrWithOldImage = text.substring(beginStr.length,pointOfSuffix+4)
	        //alert("subStrWithOldImage: " + subStrWithOldImage);
    	      //want to get where the imageSuffixIs
	          //pointOfSuffix = subStrWithOldImage.indexOf(imageSuffix,0)

    	//get the ending of the string after the image name ... it is +5 because
	// we want the char after .png
   	    endStr = text.substring(pointOfSuffix+4,text.length)
	//alert("endStr: " + endStr); 
	newString = beginStr + img_src + endStr

	//alert("tmp: " + tmp +  " TMP INDEX: " + tmpIndex+ "  TEXT: " + text + " beginStr: " + beginStr + " END:                         " + endStr + "                           NEW: " + newString);

	//alert("childnode text: " + text + " &&&&&&&&&&&&&&&&&&&&&& new text: " + newString);

    	child_node[0].text = newString
     }
    }
    getNodeFromIdAndUpdateText(child_node, id,img_src,img_name)
  }
}

// This function writes all the child node for whatever
// parent node is specified as the argument. Note that
// this function is called recursively whenever any
// child node has children of its own.

function write_children(parent_node, nodebelow) {

    var child_node
    var indent_width
    var indents
    var tempstr

    // Run through all of the parent's child nodes
    // parent_node[0] refers to the parent node itself, so start at 1
    for (var counter = 1; counter < parent_node.length; counter++) {
        tempstr = nodebelow
        // Store the child node
        child_node = parent_node[counter]
        
        // First check to see if this is a folder or a document
        var its_a_folder = true
        if (child_node[0].type == "child") {
            its_a_folder = false
        }

        frames["tree_frame"].document.writeln('<tr class="indent' + nodebelow.length + '">');
       //width below was 185 
        frames["tree_frame"].document.writeln('<td valign="bottom" width="185" nowrap >')

        for (var x=0; x< nodebelow.length; x++){
          if (tempstr.substring(0,1) == "0"){
             frames["tree_frame"].document.writeln('<img src="../menu_images/invisible.gif" width="13" height="18" vspace="0" hspace="0" border="0" align="left">')
          }else {
             frames["tree_frame"].document.writeln('<img src="../menu_images/treebar.gif" align="left" border="0" vspace="0" hspace="0" width="18" height="18">')
          }
          tempstr = tempstr.substring(1, tempstr.length)
//frames["tree_frame"].document.writeln('<td>tempstr: ' + tempstr + ' x: ' + x +'</td>')
        }

        // Handle folders and documents separately
        if (its_a_folder) {

            //frames["tree_frame"].document.writeln('<a href=#'+child_node[0].id + ' onclick="javascript:parent.toggle_state(\'' + child_node[0].index + '\')">')
            frames["tree_frame"].document.writeln('<a name=#'+child_node[0].id + ' onclick="javascript:parent.toggle_state(\'' + child_node[0].index + '\',event)">')
            
            if (child_node[0].state == "closed") {
                 if (counter != parent_node.length -1 ) {
                    frames["tree_frame"].document.write('<img class="clickme" src="../menu_images/menu_tee_plus.gif" align="left" border="0" vspace="0" hspace="0" width="18" height="18"></a>')
                 } else {
                    frames["tree_frame"].document.write('<img class="clickme" src="../menu_images/menu_corner_plus.gif" align="left"  border="0" vspace="0" hspace="0" width="18" height="18"></a>')
                 }
	      if (child_node[0].url == "folder"){
	 	 frames["tree_frame"].document.write('<img src="../menu_images/closed.gif"   border="0" align="left" vspace="0" hspace="0" width="18" height="18">')
              }
            }
            else {
                if (counter != parent_node.length -1 ) {
                    frames["tree_frame"].document.write('<img class="clickme" src="../menu_images/menu_tee_minus.gif" align="left" border="0" vspace="0" hspace="0" width="18" height="18"></a>')
                 } else {
                    frames["tree_frame"].document.write('<img class="clickme" src="../menu_images/menu_corner_minus.gif" align="left" border="0" vspace="0" hspace="0" width="18" height="18"></a>')
                 }
                
	     if (child_node[0].url == "folder"){
	 	frames["tree_frame"].document.write('<img src="../menu_images/open.gif" align="left" border="0" vspace="0" hspace="0" width="18" height="18">')
              }
            }
            //frames["tree_frame"].document.writeln('<\/td>')
            //frames["tree_frame"].document.writeln('<td>')
            frames["tree_frame"].document.writeln(child_node[0].text)
            
            frames["tree_frame"].document.writeln('<\/td>')

            frames["tree_frame"].document.writeln('<\/tr>')
            //frames["tree_frame"].document.writeln('<\/table>')

            // If this child's state is "open", recursively call
            // this function to write the child's children (if any)
            if (child_node[0].state == "open") {
               if (counter != parent_node.length-1)
                write_children(child_node, nodebelow+"1")
               else {
                write_children(child_node, nodebelow+"0")
               }
            }
        }
        else {
        
            // Is it the currently displayed document?
            if (child_node[0].index == current_document) {
                frames["tree_frame"].document.writeln(child_node[0].text)
            }
            else {
               //if to determine whether to use corner or tee image
               if (counter != parent_node.length-1){
                  frames["tree_frame"].document.writeln('<img src=../menu_images/treetee.gif  align="left" border="0" vspace="0" hspace="0" width="18" height="18">') 
               } else {
                  frames["tree_frame"].document.writeln('<img src=../menu_images/treecorner.gif align="left" border="0" vspace="0" hspace="0" width="18" height="18">')
               }
               frames["tree_frame"].document.writeln(child_node[0].text)
            }                        
            frames["tree_frame"].document.writeln('<\/td>')
            frames["tree_frame"].document.writeln('<\/tr>')
        }
    }
}

function write_right_click_menu() {
    if (rightClickMenuPainter == 0){
       timeout = setTimeout("doNothingRightClick()",50)
    }else {
       timeout = setTimeout("createRightClickMenu()",50)
    }
}

function write_menu_from_server(){
    if (painter == 0){
       timeout = setTimeout("doNothing()",50)
    }else {
       timeout = setTimeout("write_menu()",50)
    }							  
}

function doNothingRightClick(){
    write_right_click_menu()
}

function doNothing(){
    write_menu_from_server()
}


function refresh_tree_after_update() {
 //alert("parentindex: "+ parentIndexLastClicked + " childindex: " + childIndexLastClicked);
 // Get the node from the global nodes_array
  tmp_child_node = nodes_array[childIndexLastClicked]
  child_node_length = tmp_child_node.length

  // only refresh if the child node has no children below it otherwise don't refresh parent
  // the reason to refresh the parent is to get the plus sign next to the child
  if (parentIndexLastClicked != 0 && child_node_length == 1 && tmp_child_node[0].type == "child") {
    parent_tmp_node = nodes_array[parentIndexLastClicked]
    parent_tmp_node[0].state="closed"
    parent_tmp_node.length=1
    get_children_from_server(parentIndexLastClicked)
  } else if (parentIndexLastClicked == 0) {
    build_tree()
    //finish()
  }

 tmp_node = nodes_array[childIndexLastClicked]
 if (tmp_node[0].state== "open") {
   tmp_node[0].state="closed"
   tmp_node.length=1
   get_children_from_server(childIndexLastClicked)
 }
 //toggle_state(childIndexLastClicked)
 //toggle_state(childIndexLastClicked)

}


// FIXME: this method is almost the same as toggle_state might want to make them one function
function get_children_from_server(node_index) {
   // Get the node from the global nodes_array
   current_node = nodes_array[node_index]

   // Store the node's current state
   current_state = current_node[0].state

   //store the anchor value
   anchorName=current_node[0].id

   frames["content_frame"].document.writeln('<html><body class="base">')
   frames["content_frame"].document.writeln('<form name=test method="post" action="ServiceInstanceTreeServlet" target=refresh_frame>')
   frames["content_frame"].document.writeln('<input type="hidden" name="id" value="'+current_node[0].id+'">');
   frames["content_frame"].document.writeln('<input type="hidden" name="ShowParentsChildrenChooser" value="'+showParentsChildrenChooser+'">');
    frames["content_frame"].document.writeln('<input type="hidden" name="treeTemplate" value="<%=treeTemplate%>">');

   frames["content_frame"].document.writeln('</form>');
   frames["content_frame"].document.writeln('</body></html>');
   frames["content_frame"].document.test.submit()
   write_menu_from_server()

   // Change it to the other state
   if (current_state == "open") {
       current_node[0].state = "closed"
   }
   else {
       current_node[0].state = "open"
   }

   // Is this a document?
   if (current_node.length == 1) {
      if (current_document != -1) {
         nodes_array[current_document].state = "closed"
         // Rewrite the menu
         timeout_id = setTimeout("write_menu()", 50)
      }
      current_document = current_node[0].index
      // if you want the document to execute uncomment next line
      //frames["content_frame"].location = current_node[0].url
    }
}


function toggle_state(node_index,event) {
    // get children is happening can't do updates
    updater = true;

	 // alert("y: " + event.y + " pageY: " + event.pageY + " screenY: " + event.screenY + " clientY: " +  event.clientY + " height: " + frames["tree_frame"].window.height);

	  // store the click location    
		clickLocation = frames["tree_frame"].document.body.scrollTop;

    // Get the node from the global nodes_array
    current_node = nodes_array[node_index]

    // Store the node's current state
    current_state = current_node[0].state
    //alert("current_state is: " + current_state);
    //store the anchor value
    anchorName=current_node[0].id
    
    if (current_state == "closed" && current_node.length == 1){
        frames["content_frame"].document.writeln('<html><body class="base">')
        frames["content_frame"].document.writeln('<form name=test method="post" action="ServiceInstanceTreeServlet?treeID=' + treeID + '" target=content_frame>')
        frames["content_frame"].document.writeln('<input type="hidden" name="id" value="'+current_node[0].id+'">');
        frames["content_frame"].document.writeln('<input type="hidden" name="ShowParentsChildrenChooser" value="'+showParentsChildrenChooser+'">');
    frames["content_frame"].document.writeln('<input type="hidden" name="treeTemplate" value="<%=treeTemplate%>">');
	
        frames["content_frame"].document.writeln('</form>');							    
        frames["content_frame"].document.writeln('</body></html>');
        frames["content_frame"].document.test.submit()						  
        write_menu_from_server()
    } else {
        timeout_id = setTimeout("write_menu()", 50)
    }
    // Change it to the other state
    if (current_state == "open") {
        current_node[0].state = "closed"
    }
    else {
        current_node[0].state = "open"
    }
    
    // Is this a document?
       if (current_node.length == 1) {
        if (current_document != -1) {
            nodes_array[current_document].state = "closed"
            // Rewrite the menu
            timeout_id = setTimeout("write_menu()", 50)
        }
        current_document = current_node[0].index
        // if you want the document to execute uncomment next line
        //frames["content_frame"].location = current_node[0].url
    }
    					     
    
}

// default RAD select function;

function setOnSelectFunction(functionName_) {
  onSelectedFunction=functionName_;
}

function executeAction(action) {
    // the vpm message seem to have a plus sign between new vpmmessage
    // so I'm just stripping out the plus sign
    //alert(action); 
    action = action.replace("+"," ");

    // for MBC encoding, we need to prepend %25 to all encodings
    action = action.replace(/%/g, "%25");

    //alert("here parent: "+ parent);
    //alert(action); 
    // When running the tree in standalone mode you won't have the parent
    // object.  So we are going to strip off parent. so we can use the local
    // messaging.  I'm testing to see if we have messaging by seeing if that 
    // function is in the local namespace.
    var testForVPM = document.getElementById('vpmSendMessage');
    if(testForVPM != null) {
      if (vpmSendMessage) {
        action = action.replace(/parent\./g,"");
      }
    } else {
      // although vpm may be available, parent may not have visibility to it?
      if (!parent.vpmSendMessage) {
        action = action.replace(/parent\./g,"");
      }
    }

    // alert("action is: " + action);
    // do action subsitutions 
    //var replace = /__ServiceInstanceID__/;
    //action = action.replace(replace,"1:"+actionInstanceID);

    //alert(action + "        javascript:alert('test3')");
    //action="javascript:alert('test3')";

    //frames["tree_frame"].location = "javascript:top.frames['dashboard'].dispatchAction('RightClickEditInstance','64')";
    //parent.location = "javascript:top.frames['dashboard'].dispatchAction('RightClickEditInstance','64')";

    //top.frames['dashboard'].dispatchAction('RightClickEditInstance','64');
    //parent.createNewInstance();
    //alert(top.frames.length + " dash: " + top.frames['dashboard']);
    //this.location="javascript:top.frames['dashboard'].dispatchAction('RightClickEditInstance', '1:64')";
    if (action.indexOf("javascript") != -1) {
      this.location=action;
    } else {
      window.open(action,"","toolbar=no,menubar=no,location=no,resizable=yes,width=340, height=220"); 
    }

    //frames["tree_frame"].location = "javascript:alert('test')"
}

var id = 0;
// Function for column headings
function displayTextDiagonal (text, down, deg, lsp) {
alert("here");
  deg = deg || 45;
  deg = Math.PI / 180 * deg;
  lsp = lsp || 10;
  dy = lsp * Math.tan(deg);
  var html = '';
  html += '<DIV ID="td' + id + '"' + ' CLASS="positioned"' + '>';
  if (down) {
    for (var r = 0; r < text.length; r++) {
      html += '<SPAN ID="td' + id + r 
             + '" CLASS="positioned" STYLE="left: ' 
             + (r * lsp) + 'px; top: ' + (r * dy) + 'px;">'; 
      html += text.charAt(r);
      html += '</SPAN>';
    }
  }
  else {
    for (var r = 0; r < text.length; r++) {
      html += '<SPAN ID="td' + id + r 
              + '" CLASS="positioned" STYLE="left: ' 
              + (r * lsp) + 'px; top: ' 
              + ((text.length - r) * dy) + 'px;">'; 
      html += text.charAt(r);
      html += '</SPAN>';
    }
  }
  html += '<\/DIV>';
  id++;
  document.write(html);
}

</script>



	<%
          SessionBeanStore sessionBeanStore = SessionBeanStore.getInstance();		  
	  SessionTagBean sessionTagBean =
	    sessionBeanStore.
	    getSessionTagBean(ServiceTypeBean.DEFAULT_TAG_NAME, request);
          RADFacadeIfc radFacadeIfc = 
	    sessionBeanStore.getFacadeForRequest(request);
          List allInstancePairs = (List) radFacadeIfc.getAllInstanceNameIDPairs();
	  boolean hasInstances = true;
	  if (allInstancePairs.size() == 0) {
	    hasInstances = false;
          }

          boolean hasTemplates = true;
          if (!hasInstances) {
            List templates = (List) radFacadeIfc.getAllTagNameIDPairs();
	    if (templates.size() == 1) {
              hasTemplates = false;
            }
          }

	  // If there are no instances, give the user some guidance
	  // NOTE: This is essentially a copy of what is in service_navigator_frame, but
 	  // it must be here as well to show up when the tree shows up in the Desktop view
	  // which is not in service_navigator_frame.  We need it in both places because
	  // the look and feel would be different otherwise.
	  // SDP

	  if (!hasInstances && !hasTemplates) {
         %>
		<span class="inlineHelpText" id="parentToolTipHolder">
  		  <p></p><p>Your RAD server currently has no Service Instances and no Templates defined.  The first step in creating a business service model is to create Templates.</p>

		  <p>You are currently viewing the read-only (end user) RAD Service View.  To create Templates, please switch to <b>RAD Administration</b> in the View selector at the top of the browser.</p>
		</span>

         <% } else if (!hasInstances && hasTemplates) { %>
		<span class="inlineHelpText" id="parentToolTipHolder">
		  <p>
                    Your server currently has no Service Instances, but it does have some Templates.
                  </p>

	          <p>You can create a Service Instance by clicking <img src="../images/button_toolbar_new_instance_over.png"> on the toolbar.</p>
		</span>


         <% } else { %>


<frameset cols="99%,1%,0%,0%" onLoad="build_tree()" frameborder="0" border="0" framespacing="0">
    <frame src="Tree" name="tree_frame"> 
    <frame src="Content" name="content_frame">
		<frame src="Content" name="refresh_frame">
		<frame src="Content" name="action_frame">
</frameset> 

	 <% } %>


</html>
